Properties Methods Events Config Options Direct Link

    Observable
      AbstractSelectionModel
        RowSelectionModel
          CheckboxSelectionModel

# Class Ext.grid.CheckboxSelectionModel

Package: | Ext.grid
Defined In: | CheckboxSelectionModel.js
Class: | CheckboxSelectionModel
Extends: | RowSelectionModel

A custom selection model that renders a column of checkboxes that can be toggled to select or deselect rows.

## Config Options

Config Options | Defined By
--- | ---
| checkOnly : Boolean `true` if rows can only be selected by clicking on the checkbox column (defaults to `false`). | CheckboxSelectionModel

header : String
Any valid text or HTML fragment to display in the header cell for the checkbox column. Defaults to:'&lt;div class="x...
Any valid text or HTML fragment to display in the header cell for the checkbox column. Defaults to:

    '<div class="x-grid3-hd-checker">&#160;</div>'

The default CSS class of `'x-grid3-hd-checker'` displays a checkbox in the header and provides support for automatic check all/none behavior on header click. This string can be replaced by any valid HTML fragment, including a simple text string (e.g., `'Select Rows'`), but the automatic check all/none behavior will only work if the `'x-grid3-hd-checker'` class is supplied.

CheckboxSelectionModel

listeners : Object
A config object containing one or more event handlers to be added to this object during initialization. This should ...

A config object containing one or more event handlers to be added to this object during initialization. This should be a valid listeners config object as specified in the addListener example for attaching multiple handlers at once.

DOM events from ExtJs Components

While some ExtJs Component classes export selected DOM events (e.g. "click", "mouseover" etc), this is usually only done when extra value can be added. For example the DataView's `click` event passing the node clicked on. To access DOM events directly from a Component's HTMLElement, listeners must be added to the Element after the Component has been rendered. A plugin can simplify this step:

    // Plugin is configured with a listeners config object.
    // The Component is appended to the argument list of all handler functions.
    Ext.DomObserver = Ext.extend(Object, {
        constructor: function(config) {
            this.listeners = config.listeners ? config.listeners : config;
        },

        // Component passes itself into plugin's init method
        init: function(c) {
            var p, l = this.listeners;
            for (p in l) {
                if (Ext.isFunction(l[p])) {
                    l[p] = this.createHandler(l[p], c);
                } else {
                    l[p].fn = this.createHandler(l[p].fn, c);
                }
            }

            // Add the listeners to the Element immediately following the render call
            c.render = c.render.createSequence(function() {
                var e = c.getEl();
                if (e) {
                    e.on(l);
                }
            });
        },

        createHandler: function(fn, c) {
            return function(e) {
                fn.call(this, e, c);
            };
        }
    });

    var combo = new Ext.form.ComboBox({

        // Collapse combo when its element is clicked on
        plugins: [ new Ext.DomObserver({
            click: function(evt, comp) {
                comp.collapse();
            }
        })],
        store: myStore,
        typeAhead: true,
        mode: 'local',
        triggerAction: 'all'
    });

Observable

| moveEditorOnEnter : Boolean false to turn off moving the editor to the next row down when the enter key is pressed or the next row up when shift ... `false` to turn off moving the editor to the next row down when the enter key is pressed or the next row up when shift + enter keys are pressed. | RowSelectionModel
| singleSelect : Boolean `true` to allow selection of only one row at a time (defaults to `false` allowing multiple selections) | RowSelectionModel
| sortable : Boolean `true` if the checkbox column is sortable (defaults to `false`). | CheckboxSelectionModel
| width : Number The default width in pixels of the checkbox column (defaults to `20`). | CheckboxSelectionModel

## Public Properties

Property | Defined By
--- | ---
| grid : Object The GridPanel for which this SelectionModel is handling selection. Read-only. | AbstractSelectionModel

## Public Methods

Method | Defined By
--- | ---

CheckboxSelectionModel( `Object config` )
Parameters:

- `config` : Object
  The configuration options

Returns:

- void

CheckboxSelectionModel

addEvents( `Object|String o`, `string Optional.` ) : void
Adds the specified events to the list of events which this Observable may fire.
Adds the specified events to the list of events which this Observable may fire.
Parameters:

- `o` : Object|String
  Either an object with event names as properties with a value of `true` or the first event name string if multiple event names are being passed as separate parameters.
- `Optional.` : string
  Event name if multiple event names are being passed as separate parameters. Usage:

      this.addEvents('storeloaded', 'storecleared');

Returns:

- void

Observable

addListener( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this object.
Appends an event handler to this object.
Parameters:

- `eventName` : String
  The name of the event to listen for.
- `handler` : Function
  The method the event invokes.
- `scope` : Object
  (optional) The scope (`this` reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.
- `options` : Object
  (optional) An object containing handler configuration. properties. This may contain any of the following properties:
  - scope : Object
    The scope (`this` reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.
  - delay : Number
    The number of milliseconds to delay the invocation of the handler after the event fires.
  - single : Boolean
    True to add a handler to handle just the next firing of the event, and then remove itself.
  - buffer : Number
    Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.
  - target : Observable
    Only call the handler if the event was fired on the target Observable, not if the event was bubbled up from a child Observable.

  Combining Options
  Using the options argument, it is possible to combine different types of listeners:
  A delayed, one-time listener.

      myDataView.on('click', this.onClick, this, {
      single: true,
      delay: 100
      });

  Attaching multiple handlers in 1 call
  The method also allows for a single argument to be passed which is a config object containing properties which specify multiple handlers.

      myGridPanel.on({
      'click' : {
          fn: this.onClick,
          scope: this,
          delay: 100
      },
      'mouseover' : {
          fn: this.onMouseOver,
          scope: this
      },
      'mouseout' : {
          fn: this.onMouseOut,
          scope: this
      }
      });

  Or a shorthand syntax:

      myGridPanel.on({
      'click' : this.onClick,
      'mouseover' : this.onMouseOver,
      'mouseout' : this.onMouseOut,
       scope: this
      });

Returns:

- void

Observable

clearSelections( [`Boolean fast`] ) : void
Clears all selections if the selection model is not locked.
Clears all selections if the selection model is not locked.
Parameters:

- `fast` : Boolean
  (optional) `true` to bypass the conditional checks and events described in deselectRow.

Returns:

- void

RowSelectionModel

deselectRange( `Number startRow`, `Number endRow` ) : void
Deselects a range of rows if the selection model is not locked. All rows in between startRow and endRow are also de...
Deselects a range of rows if the selection model is not locked. All rows in between startRow and endRow are also deselected.
Parameters:

- `startRow` : Number
  The index of the first row in the range
- `endRow` : Number
  The index of the last row in the range

Returns:

- void

RowSelectionModel

deselectRow( `Number row`, [`Boolean preventViewNotify`] ) : void
Deselects a row. Before deselecting a row, checks if the selection model is locked. If this check is satisfied the r...
Deselects a row. Before deselecting a row, checks if the selection model is locked. If this check is satisfied the row will be deselected and followed up by firing the rowdeselect and selectionchange events.
Parameters:

- `row` : Number
  The index of the row to deselect
- `preventViewNotify` : Boolean
  (optional) Specify `true` to prevent notifying the view (disables updating the selected appearance)

Returns:

- void

RowSelectionModel

each( `Function fn`, [`Object scope`] ) : Boolean
Calls the passed function with each selection. If the function returns false, iteration is stopped and this function ...
Calls the passed function with each selection. If the function returns `false`, iteration is stopped and this function returns `false`. Otherwise it returns `true`.
Parameters:

- `fn` : Function
  The function to call upon each iteration. It is passed the selected Record.
- `scope` : Object
  (optional) The scope (`this` reference) in which the function is executed. Defaults to this RowSelectionModel.

Returns:

- `Boolean`
  true if all selections were iterated

RowSelectionModel

enableBubble( `String/Array events` ) : void
Enables events fired by this Observable to bubble up an owner hierarchy by calling this.getBubbleTarget() if present....

Enables events fired by this Observable to bubble up an owner hierarchy by calling `this.getBubbleTarget()` if present. There is no implementation in the Observable base class.

This is commonly used by Ext.Components to bubble events to owner Containers. See Ext.Component.getBubbleTarget. The default implementation in Ext.Component returns the Component's immediate owner. But if a known target is required, this can be overridden to access the required target more quickly.

Example:

    Ext.override(Ext.form.Field, {
        //  Add functionality to Field's initComponent to enable the change event to bubble
        initComponent : Ext.form.Field.prototype.initComponent.createSequence(function() {
            this.enableBubble('change');
        }),

        //  We know that we want Field's events to bubble directly to the FormPanel.
        getBubbleTarget : function() {
            if (!this.formPanel) {
                this.formPanel = this.findParentByType('form');
            }
            return this.formPanel;
        }
    });

    var myForm = new Ext.formPanel({
        title: 'User Details',
        items: [{
            ...
        }],
        listeners: {
            change: function() {
                // Title goes red if form has been modified.
                myForm.header.setStyle('color', 'red');
            }
        }
    });

Parameters:

- `events` : String/Array
  The event name to bubble, or an Array of event names.

Returns:

- void

Observable

fireEvent( `String eventName`, `Object... args` ) : Boolean
Fires the specified event with the passed parameters (minus the event name). An event may be set to bubble up an Obse...

Fires the specified event with the passed parameters (minus the event name).

An event may be set to bubble up an Observable parent hierarchy (See Ext.Component.getBubbleTarget) by calling enableBubble.

Parameters:

- `eventName` : String
  The name of the event to fire.
- `args` : Object...
  Variable number of parameters are passed to handlers.

Returns:

- `Boolean`
  returns false if any of the handlers return false otherwise it returns true.

Observable

getCount() : Number
Gets the number of selected rows.
Gets the number of selected rows.
Parameters:

- None.

Returns:

- `Number`

RowSelectionModel

getSelected() : Record
Returns the first selected record.
Returns the first selected record.
Parameters:

- None.

Returns:

- `Record`

RowSelectionModel

getSelections() : Array
Returns the selected records
Returns the selected records
Parameters:

- None.

Returns:

- `Array`
  Array of selected records

RowSelectionModel

hasListener( `String eventName` ) : Boolean
Checks to see if this object has any listeners for a specified event
Checks to see if this object has any listeners for a specified event
Parameters:

- `eventName` : String
  The name of the event to check for

Returns:

- `Boolean`
  True if the event is being listened for, else false

Observable

hasNext() : Boolean
Returns true if there is a next record to select
Returns true if there is a next record to select
Parameters:

- None.

Returns:

- `Boolean`

RowSelectionModel

hasPrevious() : Boolean
Returns true if there is a previous record to select
Returns true if there is a previous record to select
Parameters:

- None.

Returns:

- `Boolean`

RowSelectionModel

hasSelection() : Boolean
Returns true if there is a selection.
Returns `true` if there is a selection.
Parameters:

- None.

Returns:

- `Boolean`

RowSelectionModel

isIdSelected( `String id` ) : Boolean
Returns true if the specified record id is selected.
Returns `true` if the specified record id is selected.
Parameters:

- `id` : String
  The id of record to check

Returns:

- `Boolean`

RowSelectionModel

isLocked() : Boolean
Returns true if the selections are locked.
Returns true if the selections are locked.
Parameters:

- None.

Returns:

- `Boolean`

AbstractSelectionModel

isSelected( `Number/Record index` ) : Boolean
Returns true if the specified row is selected.
Returns `true` if the specified row is selected.
Parameters:

- `index` : Number/Record
  The record or index of the record to check

Returns:

- `Boolean`

RowSelectionModel

lock() : void
Locks the selections.
Locks the selections.
Parameters:

- None.

Returns:

- void

AbstractSelectionModel

on( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this object (shorthand for addListener.)
Appends an event handler to this object (shorthand for addListener.)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `scope` : Object
  (optional) The scope (`this` reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.
- `options` : Object
  (optional) An object containing handler configuration.

Returns:

- void

Observable

purgeListeners() : void
Removes all listeners for this object
Removes all listeners for this object
Parameters:

- None.

Returns:

- void

Observable

relayEvents( `Object o`, `Array events` ) : void
Relays selected events from the specified Observable as if the events were fired by this.
Relays selected events from the specified Observable as if the events were fired by `this`.
Parameters:

- `o` : Object
  The Observable whose events this object is to relay.
- `events` : Array
  Array of event names to relay.

Returns:

- void

Observable

removeListener( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes an event handler.
Removes an event handler.
Parameters:

- `eventName` : String
  The type of event the handler was associated with.
- `handler` : Function
  The handler to remove. This must be a reference to the function passed into the addListener call.
- `scope` : Object
  (optional) The scope originally specified for the handler.

Returns:

- void

Observable

resumeEvents() : void
Resume firing events. (see suspendEvents) If events were suspended using the queueSuspended parameter, then all event...
Resume firing events. (see suspendEvents) If events were suspended using the `queueSuspended` parameter, then all events fired during event suspension will be sent to any listeners now.
Parameters:

- None.

Returns:

- void

Observable

selectAll() : void
Selects all rows if the selection model is not locked.
Selects all rows if the selection model is not locked.
Parameters:

- None.

Returns:

- void

RowSelectionModel

selectFirstRow() : void
Selects the first row in the grid.
Selects the first row in the grid.
Parameters:

- None.

Returns:

- void

RowSelectionModel

selectLastRow( [`Boolean keepExisting`] ) : void
Select the last row.
Select the last row.
Parameters:

- `keepExisting` : Boolean
  (optional) `true` to keep existing selections

Returns:

- void

RowSelectionModel

selectNext( [`Boolean keepExisting`] ) : Boolean
Selects the row immediately following the last selected row.
Selects the row immediately following the last selected row.
Parameters:

- `keepExisting` : Boolean
  (optional) `true` to keep existing selections

Returns:

- `Boolean`
  <tt>true</tt> if there is a next row, else <tt>false</tt>

RowSelectionModel

selectPrevious( [`Boolean keepExisting`] ) : Boolean
Selects the row that precedes the last selected row.
Selects the row that precedes the last selected row.
Parameters:

- `keepExisting` : Boolean
  (optional) `true` to keep existing selections

Returns:

- `Boolean`
  <tt>true</tt> if there is a previous row, else <tt>false</tt>

RowSelectionModel

selectRange( `Number startRow`, `Number endRow`, [`Boolean keepExisting`] ) : void
Selects a range of rows if the selection model is not locked. All rows in between startRow and endRow are also select...
Selects a range of rows if the selection model is not locked. All rows in between startRow and endRow are also selected.
Parameters:

- `startRow` : Number
  The index of the first row in the range
- `endRow` : Number
  The index of the last row in the range
- `keepExisting` : Boolean
  (optional) True to retain existing selections

Returns:

- void

RowSelectionModel

selectRecords( `Array records`, [`Boolean keepExisting`] ) : void
Select records.
Select records.
Parameters:

- `records` : Array
  The records to select
- `keepExisting` : Boolean
  (optional) `true` to keep existing selections

Returns:

- void

RowSelectionModel

selectRow( `Number row`, [`Boolean keepExisting`], [`Boolean preventViewNotify`] ) : void
Selects a row. Before selecting a row, checks if the selection model is locked and fires the beforerowselect event. ...
Selects a row. Before selecting a row, checks if the selection model is locked and fires the beforerowselect event. If these checks are satisfied the row will be selected and followed up by firing the rowselect and selectionchange events.
Parameters:

- `row` : Number
  The index of the row to select
- `keepExisting` : Boolean
  (optional) `true` to keep existing selections
- `preventViewNotify` : Boolean
  (optional) Specify `true` to prevent notifying the view (disables updating the selected appearance)

Returns:

- void

RowSelectionModel

selectRows( `Array rows`, [`Boolean keepExisting`] ) : void
Selects multiple rows.
Selects multiple rows.
Parameters:

- `rows` : Array
  Array of the indexes of the row to select
- `keepExisting` : Boolean
  (optional) `true` to keep existing selections (defaults to `false`)

Returns:

- void

RowSelectionModel

suspendEvents( `Boolean queueSuspended` ) : void
Suspend the firing of all events. (see resumeEvents)
Suspend the firing of all events. (see resumeEvents)
Parameters:

- `queueSuspended` : Boolean
  Pass as true to queue up suspended events to be fired after the resumeEvents call instead of discarding all suspended events;

Returns:

- void

Observable

un( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes an event handler (shorthand for removeListener.)
Removes an event handler (shorthand for removeListener.)
Parameters:

- `eventName` : String
  The type of event the handler was associated with.
- `handler` : Function
  The handler to remove. This must be a reference to the function passed into the addListener call.
- `scope` : Object
  (optional) The scope originally specified for the handler.

Returns:

- void

Observable

unlock() : void
Unlocks the selections.
Unlocks the selections.
Parameters:

- None.

Returns:

- void

AbstractSelectionModel

## Public Events

Event | Defined By
--- | ---

beforerowselect : ( `SelectionModel this`, `Number rowIndex`, `Boolean keepExisting`, `Record record` )
Fires before a row is selected, return false to cancel the selection.
Fires before a row is selected, return false to cancel the selection.
Listeners will be called with the following arguments:

- `this` : SelectionModel
- `rowIndex` : Number
  The index to be selected
- `keepExisting` : Boolean
  False if other selections will be cleared
- `record` : Record
  The record to be selected

RowSelectionModel

rowdeselect : ( `SelectionModel this`, `Number rowIndex`, `Record record` )
Fires when a row is deselected. To prevent deselection lock the selections.
Fires when a row is deselected. To prevent deselection lock the selections.
Listeners will be called with the following arguments:

- `this` : SelectionModel
- `rowIndex` : Number
- `record` : Record

RowSelectionModel

rowselect : ( `SelectionModel this`, `Number rowIndex`, `Ext.data.Record r` )
Fires when a row is selected.
Fires when a row is selected.
Listeners will be called with the following arguments:

- `this` : SelectionModel
- `rowIndex` : Number
  The selected index
- `r` : Ext.data.Record
  The selected record

RowSelectionModel

selectionchange : ( `SelectionModel this` )
Fires when the selection changes
Fires when the selection changes
Listeners will be called with the following arguments:

- `this` : SelectionModel

RowSelectionModel